/* Copyright (C) 1993 by Thomas Glen Smith.  All Rights Reserved. */
/* apltokcd.h - APL2 V1.0.0 ********************************************
* Contains definitions for special token codes that may appear in      *
* field token_code of struct apltoken.  The QUAD_xx definitions must   *
* remain negative and contiguous, with QUAD_AI first and QUAD_ZZ last. *
* Token codes 256 and above are reserved for user-defined function     *
* types.  See aplfunc.h and apltoken.h.                                *
***********************************************************************/
#if !defined(APLTOKCD_INCL)
#define APLTOKCD_INCL
#define DEFINED_FUNCTION 256
#define NO_MORE_TOKENS -2
#define VECTOR_TOKEN -3
#define OPERAND_TOKEN -4
#define MESSAGE_TOKEN -5
#define DERIVED_FUNCTION -7
#define AXIS_INDEX_TOKEN -8
#define NULL_TOKEN -9
#define FUNCTION_TOKEN -10
#define QUAD_AI -11
#define QUAD_AV -12
#define QUAD_CR -13
#define QUAD_CT -14
#define QUAD_DL -15
#define QUAD_EX -16
#define QUAD_FX -17
#define QUAD_HT -18
#define QUAD_IO -19
#define QUAD_LC -20
#define QUAD_LX -21
#define QUAD_NC -22
#define QUAD_NL -23
#define QUAD_PP -24
#define QUAD_PW -25
#define QUAD_RL -26
#define QUAD_TC -27
#define QUAD_TS -28
#define QUAD_TT -29
#define QUAD_UL -30
#define QUAD_WA -31
#define QUAD_EA -32
#define QUAD_FC -33
#define QUAD_TZ -34
#define QUAD_ZZ -99
#define TOKPERM 1
#endif
